﻿//******************************************************** 
// Přestupné sekundy 
//******************************************************** 
var deltaTT = 32.184;
var leapSeconds = new Array();
//========================================================
function SetLeaps(year, month, day, sec)
{
 this.Datum = new Date(year, month - 1, day);
 this.Leaps = sec;
} 
//======================================================== 
leapSeconds[0] = new SetLeaps( 1972, 1, 1, 10 );
leapSeconds[1] = new SetLeaps( 1972, 6, 1, 1  ); 
leapSeconds[2] = new SetLeaps( 1973, 1, 1, 1  );
leapSeconds[3] = new SetLeaps( 1974, 1, 1, 1  );
leapSeconds[4] = new SetLeaps( 1975, 1, 1, 1  );
leapSeconds[5] = new SetLeaps( 1976, 1, 1, 1  );
leapSeconds[6] = new SetLeaps( 1977, 1, 1, 1  );
leapSeconds[7] = new SetLeaps( 1978, 1, 1, 1  );
leapSeconds[8] = new SetLeaps( 1979, 1, 1, 1  );
leapSeconds[9] = new SetLeaps( 1980, 1, 1, 1  );
leapSeconds[10] = new SetLeaps( 1981, 6, 1, 1  );
leapSeconds[11] = new SetLeaps( 1982, 6, 1, 1  );
leapSeconds[12] = new SetLeaps( 1983, 6, 1, 1  );
leapSeconds[13] = new SetLeaps( 1985, 6, 1, 1  );
leapSeconds[14] = new SetLeaps( 1988, 1, 1, 1  );
leapSeconds[15] = new SetLeaps( 1990, 1, 1, 1  );
leapSeconds[16] = new SetLeaps( 1991, 1, 1, 1  );
leapSeconds[17] = new SetLeaps( 1992, 6, 1, 1  );
leapSeconds[18] = new SetLeaps( 1993, 6, 1, 1  );
leapSeconds[19] = new SetLeaps( 1994, 6, 1, 1  );
leapSeconds[20] = new SetLeaps( 1996, 1, 1, 1  );
leapSeconds[21] = new SetLeaps( 1997, 6, 1, 1  );
leapSeconds[22] = new SetLeaps( 1999, 1, 1, 1  );
leapSeconds[23] = new SetLeaps( 2006, 1, 1, 1  );
leapSeconds[24] = new SetLeaps( 2009, 1, 1, 1  );
leapSeconds[25] = new SetLeaps( 2012, 6, 1, 1 );
leapSeconds[26] = new SetLeaps( 2015, 6, 1, 1 );
leapSeconds[27] = new SetLeaps( 2017, 1, 1, 1 );
//========================================================
function GetLeapSeconds(date)
{
 var leaps = 0;
 
 for(var i = 0; i < leapSeconds.length; i++)
 {
  if(date >= leapSeconds[i].Datum)
      leaps += leapSeconds[i].Leaps;
 }
 
 return leaps;
}
//========================================================

//******************************************************** 
// Julánský den
//******************************************************** 
Date.prototype.JulianDay = function() 
{
 // Date() je v UTC a je počítáno v milisekundách od 1.1.1970 00:00:00 UTC
 // 1.1.1970 00:00:00 UTC = 2440587.5 JD
 return (this * 1e-3 / 86400.0 + 2440587.5);
}
//========================================================
Date.JulianDay = function(datum) 
{
 // Date() je v UTC a je počítáno v milisekundách od 1.1.1970 00:00:00 UTC
 // 1.1.1970 00:00:00 UTC = 2440587.5 JD
 return (datum.valueOf() * 1e-3 / 86400.0 + 2440587.5);
}
//========================================================
Date.prototype.JulianDayTT = function() 
{
 return (this.JulianDay() + (deltaTT + GetLeapSeconds(this)) / 86400.0 );
}
//========================================================
Date.JulianDayTT = function(datum) 
{
 return (Date.JulianDay(datum) + (deltaTT + GetLeapSeconds(datum)) / 86400.0);
}
//========================================================
Date.prototype.JulianDayTDB = function() 
{
 var JD = this.JulianDayTT();
 var MJD = JD - 2400000.5;
 var fi = Angle.ToRad(357.53 + 0.98560028 * (MJD - 51544.5));
 var delta = 0.001658 * Math.sin(fi) + 0.000014 * Math.sin(2 * fi);
 return JD + delta / 86400.0;
}
//========================================================
Date.JulianDayTDB = function(datum) 
{
 var JD = Date.JulianDayTT(datum);
 var MJD = JD - 2400000.5;
 var fi = Angle.ToRad(357.53 + 0.98560028 * (MJD - 51544.5));
 var delta = 0.001658 * Math.sin(fi) + 0.000014 * Math.sin(2 * fi);
 return JD + delta / 86400.0;
}
//========================================================
Date.prototype.MSD = function(lon) 
{    
 var msd = (((this.JulianDayTT() - 2451549.5) / 1.02749125083113) + 44796.0 - 0.00096);
 
 if(lon != null)
  msd -= (lon / 360.0);
 
 return msd;
}
//========================================================
Date.prototype.Delta2000 = function() 
{
 return (this.JulianDayTDB() - 2451545.0);
}
//========================================================
Date.prototype.DeltaTT = function() 
{
 return deltaTT + GetLeapSeconds(this);
}
//========================================================
Date.prototype.DeltaTDB = function() 
{
 var JD = this.JulianDayTT();
 var MJD = JD - 2400000.5;
 var fi = Angle.ToRad(357.53 + 0.98560028 * (MJD - 51544.5));
 var delta = 0.001658 * Math.sin(fi) + 0.000014 * Math.sin(2 * fi);
 return delta;
}
//========================================================
Date.prototype.DeltaUT = function()
{
 var JD = Date.JulianDayTDB(this);
 var d0 = Date.UTC(this.getUTCFullYear(), 0 ,1);
 var JD0 = Date.JulianDayTDB(d0);
 
 return Date.DeltaUT(this.getUTCFullYear(), JD - JD0);
}
//========================================================
Date.DeltaUT = function(year, day)
{
 var deltaT = 0;
 var y = year + day / 365.25;
 var t;
 
 if(year > 1941 && year <= 1961)
 {
  t = y - 1950;
  deltaT = 29.07 + 0.407 * t - Math.pow(t, 2) / 233 + Math.pow(t, 3) / 2547;
 }

 if(year > 1961 && year <= 1986)
 {
  t = y - 1975;
  deltaT = 45.45 + 1.067 * t - Math.pow(t, 2) / 260 - Math.pow(t, 3) / 718;
 }

 if(year > 1986 && year <= 2005)
 {
  t = y - 2000;
  deltaT = 63.86 + 0.3345 * t - 0.060374 * Math.pow(t, 2) + 0.0017275 * Math.pow(t, 3) + 0.000651814 * Math.pow(t, 4) + 0.00002373599 * Math.pow(t, 5);
 }

 if(year > 2005 && year <= 2015)
 {
  t = y - 2005;
  deltaT = 64.54760559 + 0.49785138 * t - 0.23628958 * Math.pow(t, 2) + 0.08982494 * Math.pow(t, 3) - 0.01376032 * Math.pow(t, 4) + 0.00098331 * Math.pow(t, 5) - 0.00002713 * Math.pow(t, 6);
 }
 
 return deltaT;
}
//========================================================
Date.FormatTime = function(time, isSec)
{
 var sign = Math.Sign(time);
 time = Math.abs(time);
 var hours = Math.Trunc(time);
 var min = Math.Trunc((time - hours) * 60);
 var sec = Math.Trunc((time - hours) * 3600 - min * 60); 
 hours = hours + ":" + ((min < 10) ? ("0" + min) : min);
 
 if(isSec == 1)
   hours = hours + ":" + ((sec < 10) ? ("0" + sec) : sec);
 
 if(sign < 0)
   hours = "-" + hours;
 
 return hours;
}
//========================================================
Date.FormatTimeMin = function(time)
{
 var hours = parseInt(time);
 var min = parseInt((time - hours) * 60);
 var sec = parseInt(time * 3600 - hours * 3600 - min * 60); 
 hours = ((min < 10) ? ("0" + min) : min);
 hours = hours + ":" + ((sec < 10) ? ("0" + sec) : sec);
 
 return hours;
}
//========================================================
Date.prototype.FormatUTC = function(format)
{
 var retStr = "";
 var mask;
 var isUse;
 var value;

 if(format == null) format = "dd.mm.yyyy HH:MM:ss";
 
 for(var idx = 0; idx < format.length;)
 {
  isUse = false;
  switch(format.substr(idx, 1))
  {
   case 'H':
   mask = "HH";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCHours();
    retStr += ((value < 10) ? "0" + value : value);
    idx += mask.length;
    isUse = true;
   }
   mask = "H";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCHours();
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   break;
   
   case 'M':
   mask = "MM";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCMinutes();
    retStr += ((value < 10) ? "0" + value : value);
    idx += mask.length;
    isUse = true;
   }
   mask = "M";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCMinutes();
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   break;
   
   case 's':
   mask = "ss";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCSeconds();
    retStr += ((value < 10) ? "0" + value : value);
    idx += mask.length;
    isUse = true;
   }
   mask = "s"
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCSeconds();
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   break;
   
   case 'd':
   mask = "dd";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCDate();
    retStr += ((value < 10) ? "0" + value : value);
    idx += mask.length;
    isUse = true;
   }
   mask = "d"
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCDate();
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   break;
   
   case 'm':
   mask = "mm";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCMonth() + 1;
    retStr += ((value < 10) ? "0" + value : value);
    idx += mask.length;
    isUse = true;
   }
   mask = "m"
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCMonth() + 1;
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   break;
   
   case 'y':
   mask = "yyyy";
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCFullYear();
    retStr += value;
    idx += mask.length;
    isUse = true;
   }
   mask = "yy"
   if(!isUse && mask.length <= (format.length - idx) && format.substr(idx, mask.length) == mask)
   {
    value = this.getUTCFullYear();
    retStr += value.toString().substr(2,2);
    idx += mask.length;
    isUse = true;
   }
   break;
  }
  
  if(!isUse)
  {
   retStr += format.substr(idx, 1); idx += 1;
  }
 }
 
 return retStr;
}
//******************************************************** 

//******************************************************** 
// Výpočet času na Marsu 
//******************************************************** 
function MarsTime(date, lon, lat)
{
 var delta2000; // Aktuální odchylka JDTT od JDTT 2000
 var M, Mrad;   // střední anomálie Marsu
 var FMS;       // délka fiktivního středního slunce
 var PBS;       // oprava na poruchy v oběhu Marsu
 var vM;        // rozdíl pravé anomálie a střední anomálie v-M
 var Ls, Lsrad; // areocentrická délka slunce
 var EOT;       // časová rovnice pro Mars
 var MSD;       // Mars Solar Day obdoba juliánského dne pro Mras
 var MTC;       // obdoba UTC na Marsu (pro nultý poledník kráter Airy-0)
 var LMST;      // lokální střední sluneční čas pro Mars
 var LTST;      // pravý sluneční čas pro Mars
 var LTZT;      // lokální střední pásmový čas
 var RAs;       // planetografická délka slunce
 var DEs;       // planetografická deklinace slunce
 var Z;         // zenitová vzdálenost
 var H;         // výška Slunce nad obzorem
 var A;         // azimut
 var TZ;        // časové pásmo
 
 delta2000 = date.Delta2000();
 M = 19.3870 + 0.52402075 * delta2000;  Mrad = Angle.ToRad(M);
 FMS = 270.3863 + 0.52403840 * delta2000;  
 
 PBS = 0.0071 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 2.2353 + 49.409)) +
       0.0057 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 2.7543 + 168.173)) +
       0.0039 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 1.1177 + 191.837)) +
       0.0037 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 15.7866 + 21.736)) +
       0.0021 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 2.1354 + 15.704)) +
       0.0020 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 2.4694 + 95.528)) +
       0.0018 * Math.cos(Angle.ToRad(0.985626 * delta2000 / 32.8493 + 49.095)); 
       
 vM = (10.691 + 3.0e-7 * delta2000) * Math.sin(Mrad) + 0.623 * Math.sin(2 * Mrad) + 0.050 * Math.sin(3 * Mrad) + 0.005 * Math.sin(4 * Mrad) + 0.0005 * Math.sin(5 * Mrad) + PBS;
 
 Ls = Angle.ToAngle360(FMS + vM); Lsrad = Angle.ToRad(Ls);
 EOT = 2.861 * Math.sin(2 * Lsrad) - 0.071 * Math.sin(4 * Lsrad) + 0.002 * Math.sin(6 * Lsrad) - vM;
 MSD = date.MSD();
 MTC = 24 * (MSD - parseInt(MSD));
 LMST = Angle.ToHours24(MTC - lon / 15.0);
 LTST = Angle.ToHours24(LMST + EOT / 15.0);
 RAs = MTC * 15 + EOT + 180;
 DEs = Math.asin(0.42565 * Math.sin(Lsrad)) + Angle.ToRad(0.25) * Math.sin(Lsrad);
 Z = Math.acos(Math.sin(DEs) * Math.sin(Angle.ToRad(lat)) + Math.cos(DEs) * Math.cos(Angle.ToRad(lat)) * Math.cos(Angle.ToRad(lon - RAs)));
 H = 90 - Angle.ToDeg(Z);
 A = Angle.ToDeg(Math.atan2(Math.sin(Angle.ToRad(lon - RAs)),(Math.cos(Angle.ToRad(lat)) * Math.tan(DEs) - Math.sin(Angle.ToRad(lat)) * Math.cos(Angle.ToRad(lon - RAs)))));
 if(A < 0) A += 360;
 
 TZ = MarsTime.TimeZone(lon);
 LTZT = Angle.ToHours24(Math.Frac((MTC + TZ)/ 24) * 24);
 
 this.MSD = MSD;
 this.LMSD = date.MSD(lon);
 this.MTC = MTC;
 this.LMZT = LTZT;
 this.LMST = LMST;
 this.LTST = LTST;
 this.TZ = TZ;
 this.Ls = Ls;
 this.Season = MarsTime.GetSeason(Ls, lat);
 this.H = H;
 this.A = A;
 this.DEs = Angle.ToDeg(DEs);
 this.RAs = RAs;
}
//========================================================
//Časové pásmo
MarsTime.TimeZone = function(lon)
{
 var TZ;
 var fTZ;
 
 TZ = Math.Trunc(lon / 15.0);
 fTZ = Math.Frac(lon / 15.0 - TZ);
 
 if(fTZ > 0.5) TZ++;
 if(fTZ < -0.5) TZ--;
 
 if(TZ > 12) TZ -= 24;
 
 return -TZ;
}
//========================================================
// Vrátí název sezóny na Marsu
MarsTime.GetSeason = function(Ls, lat)
{
 var season = "";

 if(lat < 0) Ls = Angle.ToAngle360(Ls-180);
 if(Ls >= 0) season =   "začátek jara";
 if(Ls >= 30) season =  "jaro";
 if(Ls >= 60) season =  "konec jara";
 if(Ls >= 90) season =  "začátek léta";
 if(Ls >= 120) season = "léto";
 if(Ls >= 150) season = "konec léta";
 if(Ls >= 180) season = "zač. podzimu";
 if(Ls >= 210) season = "podzim";
 if(Ls >= 240) season = "kon. podzimu";
 if(Ls >= 270) season = "začátek zimy";
 if(Ls >= 300) season = "zima";
 if(Ls >= 330) season = "konec zimy";
 
 return season;
}
//========================================================

