﻿//******************************************************** 
// Základní konstanty (zdroj: DE405)
//********************************************************
Konst = new Object();

// Astronomická jednotka
Konst.AU = 149.597870700E+9; //149.597870691000015E+09;

// Rychlost světla
Konst.c = 299792458.0;

// Poměr hmotnosti Země a Měsíce (DE 405)
Konst.EMRAT = 81.3005600000000044;

// Poloměr Země
Konst.ERAD = 6378135;

// Poloměr Marsu
Konst.MRAD = 3376200;

// Sklon rotační osy Země J2000.0
Konst.EIN = 23.4392911111111;

// GM Slunce
Konst.GMSUN = 1.32712440017987E+20;

// Jul date 1.1.2000 12:00
Konst.JD2000 = 2451545.0;
//======================================================== 

//******************************************************** 
// Typ okna
//********************************************************
WndType = new Object();

WndType.Map = 1;
WndType.Info = 2;
WndType.Orbit = 3;
//========================================================