﻿//******************************************************** 
// Předvolby 
//********************************************************
function Preferences()
{
 // Defaultní hodnoty
 // Hodiny
 this.showLTST = true;
 
 // Zobrazení na mapě
 this.mapShowSun = true; 
 this.mapShowEarth = true; 
 this.mapShowFeatures = false;
 this.mapShowMissions = false;
 this.mapShowShadow = false;
 this.mapShowEarthVisible = false;
 
 this.mapType = false;
 
 // Místa
 this.idxSite = -1;
 this.IsLock = false;
 
 // Orbitální diagram
 this.orbShowPeri = false;
 this.orbShowLS = false;
 
 this.obsLon = 15;
 this.obsLat = 50;
 this.obsAlt = 250;
}
//========================================================
Preferences.prototype.Load = function()
{
 var mapShowSun = System.Gadget.Settings.read("mapShowSun"); 
 var mapShowEarth = System.Gadget.Settings.read("mapShowEarth"); 
 var mapShowMissions = System.Gadget.Settings.read("mapShowMissions");
 var mapShowFeatures = System.Gadget.Settings.read("mapShowFeatures");
 var mapShowShadow = System.Gadget.Settings.read("mapShowShadow");
 var mapShowEarthVisible = System.Gadget.Settings.read("mapShowEarthVisible");
 var mapType = System.Gadget.Settings.read("mapType");
 var showLTST = System.Gadget.Settings.read("showLTST"); 
 var IsLock = System.Gadget.Settings.read("IsLock");
 var idxSite = System.Gadget.Settings.read("idxSite");
 var orbShowPeri = System.Gadget.Settings.read("orbShowPeri");
 var orbShowLS = System.Gadget.Settings.read("orbShowLS");
 
 var obsLon = System.Gadget.Settings.read("obsLon"); 
 var obsLat = System.Gadget.Settings.read("obsLat"); 
 var obsAlt = System.Gadget.Settings.read("obsAlt");
 
 if(mapShowSun.toString().length) this.mapShowSun = mapShowSun;
 if(mapShowEarth.toString().length) this.mapShowEarth = mapShowEarth;
 if(mapShowMissions.toString().length) this.mapShowMissions = mapShowMissions;
 if(mapShowFeatures.toString().length) this.mapShowFeatures = mapShowFeatures;
 
 if(mapShowShadow.toString().length) this.mapShowShadow = mapShowShadow;
 if(mapShowEarthVisible.toString().length) this.mapShowEarthVisible = mapShowEarthVisible;
 
 if(mapType.toString().length) this.mapType = mapType;
 if(showLTST.toString().length) this.showLTST = showLTST;
 if(IsLock.toString().length) this.IsLock = IsLock;
 if(idxSite.toString().length) this.idxSite = idxSite;
 if(orbShowPeri.toString().length) this.orbShowPeri = orbShowPeri;
 if(orbShowLS.toString().length) this.orbShowLS = orbShowLS;
 
 if(obsLon.toString().length) this.obsLon = parseFloat(obsLon);
 if(obsLat.toString().length) this.obsLat = parseFloat(obsLat);
 if(obsAlt.toString().length) this.obsAlt = parseFloat(obsAlt);
}
//========================================================
Preferences.prototype.Save = function()
{
 System.Gadget.Settings.write("mapShowSun", this.mapShowSun); 
 System.Gadget.Settings.write("mapShowEarth", this.mapShowEarth); 
 System.Gadget.Settings.write("mapShowMissions", this.mapShowMissions);
 System.Gadget.Settings.write("mapShowFeatures", this.mapShowFeatures);
 System.Gadget.Settings.write("mapShowShadow", this.mapShowShadow);
 System.Gadget.Settings.write("mapShowEarthVisible", this.mapShowEarthVisible);
 System.Gadget.Settings.write("mapType", this.mapType);
 System.Gadget.Settings.write("showLTST", this.showLTST);
 System.Gadget.Settings.write("IsLock", this.IsLock);
 System.Gadget.Settings.write("idxSite", this.idxSite);
 System.Gadget.Settings.write("orbShowPeri", this.orbShowPeri);
 System.Gadget.Settings.write("orbShowLS", this.orbShowLS);
 
 System.Gadget.Settings.write("obsLon", this.obsLon); 
 System.Gadget.Settings.write("obsLat", this.obsLat); 
 System.Gadget.Settings.write("obsAlt", this.obsAlt);
}
//========================================================

